Lab_PPW_2017/urls.py
from django.conf.urls import url,include
from django.views.generic import RedirectView
import lab_1.urls as lab_1
import lab_2.urls as lab_2
import lab_3.urls as lab_3
import lab_4.urls as lab_4
import lab_5.urls as lab_5
import lab_6.urls as lab_6
import lab_7.urls as lab_7
import lab_8.urls as lab_8
import lab_9.urls as lab_9
import lab_10.urls as lab_10
import lab_2_addon.urls as lab_2_addon

urlpatterns = [
    url(r'^lab-1/', include(lab_1,namespace='lab-1')),
    url(r'^lab-2/', include(lab_2,namespace='lab-2')),
    url(r'^lab-3/', include(lab_3,namespace='lab-3')),
    url(r'^lab-4/', include(lab_4,namespace='lab-4')),
    url(r'^lab-5/', include(lab_5,namespace='lab-5')),
    url(r'^lab-6/', include(lab_6,namespace='lab-6')),
    url(r'^lab-7/', include(lab_7,namespace='lab-7')),
    url(r'^lab-8/', include(lab_8,namespace='lab-8')),
    url(r'^lab-9/', include(lab_9,namespace='lab-9')),
    url(r'^lab-10/', include(lab_10,namespace='lab-10')),
    url(r'^lab-2-addon/', include(lab_2_addon,namespace='lab-2-addon')),
    url(r'^$', RedirectView.as_view(url='lab-10/', permanent=True)),
]

lab_1/urls.py
from django.conf.urls import url
from .views import index
#url for app
urlpatterns = [
    url(r'^$', index, name='index'),
]

lab_4/urls.py
from django.conf.urls import url
from .views import index,message_post,message_table

urlpatterns = [
    url(r'^$', index, name='index'),
    url(r'^add_message', message_post, name='add_message'),
    url(r'^result_table', message_table, name='result_table'),
 ]

lab_4/models.py
from django.db import models

class Message(models.Model):
    name = models.CharField(max_length=27)
    email = models.EmailField()
    message = models.TextField()
    created_date = models.DateTimeField(auto_now_add=True)

    def __str__(self):
        return self.message

lab_4/forms.py
from django import forms


class Message_Form(forms.Form):
    error_messages = {
        'required': 'Tolong isi input ini',
        'invalid': 'Isi input dengan email',
    }
    attrs = {
        'class': 'form-control'
    }

    name = forms.CharField(label='Nama', required=False, max_length=27, empty_value='Anonymous', widget=forms.TextInput(attrs=attrs))
    email = forms.EmailField(required=False, widget=forms.EmailInput(attrs=attrs))
    message = forms.CharField(widget=forms.Textarea(attrs=attrs), required=True)

lab_4/views.py
from django.shortcuts import render
from lab_2.views import landing_page_content
from django.http import HttpResponseRedirect
from django.contrib import messages
from .forms import Message_Form
from .models import Message


# Create your views here.
about_me = ['Funny','Easy Going','Food Lovers','Traveller','Childish','Optimistic']
response = {'author': "Naufal Ihsan Pratama",'about': about_me,'content': landing_page_content}



def index(request):
    response['content'] = landing_page_content
    html = 'lab_4/lab_4.html'
    response['about_me'] = about_me
    response['message_form'] = Message_Form
    return render(request, html, response)

def message_post(request):
    form = Message_Form(request.POST or None)
    if(request.method == 'POST' and form.is_valid()):
        response['name'] = request.POST['name'] if request.POST['name'] != "" else "Anonymous"
        response['email'] = request.POST['email'] if request.POST['email'] != "" else "Anonymous"
        response['message'] = request.POST['message']
        message = Message(name=response['name'], email=response['email'],
                          message=response['message'])
        message.save()
        html ='lab_4/form_result.html'
        return render(request, html, response)
    else:
        return HttpResponseRedirect('/lab-4/')
def message_table(request):
        message = Message.objects.all()
        response['message'] = message
        html = 'lab_4/table.html'
        return render(request, html , response)

lab_4/templates/lab_4/form_result.html
{% extends "lab_4/layout/base.html" %}
{% block title %} Pesan dari {{ name }} {% endblock %}
{% block content %}
  <textarea readonly rows="5" class="form-control">&quot;{{message}}&quot;-{{name}}
    by {{ email }}
  </textarea>
{% endblock %}

{% block footer %}
    <p> &copy; {{name}} </p>
{% endblock %}

lab_4/templates/lab_4/lab_4.html
{% extends "lab_4/layout/base.html" %}
{% load staticfiles %}

{% block content %}
<h1>Portofolio</h1>
<hr/>
<section name="bio" class="bio">
    <h2>Bio</h2>
    <p>
        {{content}}
    </p>
</section>

<aside name="profile-picture" class="picture">
  <img id="profile-picture" src="{% static 'img/profile-picture.jpg' %}" class="img-circular">
</aside>

<section name="about_me" class="about_me">
    <hr/>
    <h2>About Me</h2>
    <ul>
        {% for ii in about_me %}
        <li><a href="#about_me"> {{ ii }} </a></li>
        {% endfor %}
    </ul>
</section>
<hr/>
<section name="form" class="form">
       <h2>Send Message</h2>
       <form id="form" method="POST" action="{% url 'lab-4:add_message' %}">
           {% csrf_token %}
           {{ message_form }}
           <br>
           <button type="submit" class="btn btn-warning">Submit</button>
       </form>
   </section>

{% endblock %}

lab_4/templates/lab_4/table.html
{% extends "lab_4/layout/base.html" %}

{% block title %} Kumpulan Pesan {% endblock %}

{% block content %}
<!--  Populate semua isi pesan dari model -->
<table class="table">
    <thead>
        <th>Nama</th>
        <th>Email</th>
        <th>Pesan</th>
        <th>Dibuat Pada</th>
    </thead>
    <tbody>
        <!-- TODO, Kalau nama/email anon maka tr classnya jadi warning -->
        {% for i in message %}
        {% if i.name == 'Anonymous' or i.email == 'Anonymous' %}
        <tr class="danger"> {% else %} <tr class="success">
            {% endif %}
            <td> {{i.name}} </td>
            <td> {{i.email}} </td>
            <td> {{i.message}} </td>
            <td> {{i.created_date}} </td>
        </tr>
        {% endfor %}
    </tbody>
</table>

{% endblock %}